"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _common = require("./_common");

var _common2 = _interopRequireDefault(_common);

var _mock = require("../mock");

var _mock2 = _interopRequireDefault(_mock);

var _utils = require("./common/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getDelimiter = function getDelimiter(path) {
  var i1 = path.lastIndexOf('/');
  var i2 = path.lastIndexOf('\\');
  return i1 > i2 ? '/' : '\\';
};

var getMockName = function getMockName(path) {
  var delimiter = getDelimiter(path);
  var paths = path.split(delimiter);
  paths.splice(paths.length - 1, 0, '__mocks__');
  return paths.join(delimiter);
};

var autoMock = function autoMock(baseRequest) {
  var mockName = getMockName(baseRequest);
  if (!(0, _utils.fileExists)(mockName)) {
    return false;
  }
  var mock = new _mock2.default({});
  mock.by(mockName);
  return mock.mock;
};

var plugin = (0, _common2.default)({
  autoMock: autoMock,

  name: 'directChild'
});

exports.default = plugin;