'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _common = require('./_common');

var _common2 = _interopRequireDefault(_common);

var _globals = require('../globals');

var _globals2 = _interopRequireDefault(_globals);

var _module = require('../module');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shouldMock = function shouldMock(mock, request, parent, topModule) {
  if (mock.flag_directChildOnly) {
    return (0, _module.inParents)(parent, topModule) ? _common.PASS : _common.NO;
  }
  if (mock.flag_toBeCalledFromMock) {
    var _getScope = (0, _globals2.default)(),
        mockedModules = _getScope.mockedModules;

    return (0, _module.getModuleName)(parent) in mockedModules ? _common.PASS : _common.NO;
  }
};

var plugin = (0, _common2.default)({
  shouldMock: shouldMock,

  name: 'directChild'
});

exports.default = plugin;