'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wipe = undefined;

var _mocks = require('./mocks');

var _plugins = require('./plugins');

var _relative = require('./plugins/relative');

// which one?
var wipe = exports.wipe = typeof __webpack_require__ === 'function' ? require('wipe-webpack-cache') : require('wipe-node-cache').wipeCache;

var primaryResolver = function primaryResolver(stubs, moduleName) {
  return stubs[moduleName];
};

var resolver = function resolver(stubs, moduleName) {
  // never wipe .node(native) module
  if (moduleName.indexOf('.node') > -1) {
    return false;
  }
  return 0 || (0, _plugins.shouldWipe)(stubs, moduleName) || primaryResolver(stubs, moduleName) || (0, _relative.relativeWipeCheck)(stubs, moduleName);
};

var wipeCache = function wipeCache() {
  var primaryCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  wipe(primaryCache, primaryResolver);
  wipe((0, _mocks.getAllMocks)(), resolver);
};

exports.default = wipeCache;